<?php
/*
  $Id: cm_cp_discount_code.php
  $Loc: catalog/includes/modules/content/checkout_payment/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2016 osCommerce

  Released under the GNU General Public License
  
  Discount Code 5.0.0. BS
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com
  
  Based on Discount Codes BS 3.x and 4.x by @Tsimi and @raiwa
  Based on the Discount Code for osCommerce 2.3.1 addon by high-quality-php-coding.com 
*/


  class cm_cp_discount_code {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_CP_DISCOUNT_CODE_TITLE;
      $this->description = MODULE_CONTENT_CP_DISCOUNT_CODE_DESCRIPTION;
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';
      if (!defined('MODULE_ORDER_TOTAL_DISCOUNT_STATUS') || MODULE_ORDER_TOTAL_DISCOUNT_STATUS != 'True') {
        $this->description .=   '<div class="secWarning">' . MODULE_CONTENT_CP_DISCOUNT_CODE_OT_WARNING . '<br>
                                <a href="modules.php?set=order_total&module=ot_discount&action=install">' . MODULE_CONTENT_CP_DISCOUNT_CODE_OT_INSTALL_NOW . '</a></div>';
      }

      if ( defined('MODULE_CONTENT_CP_DISCOUNT_CODE_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_CP_DISCOUNT_CODE_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_CP_DISCOUNT_CODE_STATUS == 'True');
      }
    }

    function execute() {
      global $oscTemplate, $cart, $sess_discount_code;

      $content_width = (int)MODULE_CONTENT_CP_DISCOUNT_CODE_CONTENT_WIDTH;
   
      ob_start();
      include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
      $template = ob_get_clean();

      $oscTemplate->addContent($template, $this->group);

      $discount_script = '
<script>
function discount_submit(sid){
  if(sid){
    document.discount.sid.value=sid;
  }
  document.discount.submit();
  return false;
}

$(document).ready(function() {
    var a = 0;
    discount_code_process();
    $("#discount_code").blur(function() { if (a == 0) discount_code_process(); a = 0 });
    $("#discount_code").keypress(function(event) { if (event.which == 13) { event.preventDefault(); a = 1; discount_code_process() } });
    function discount_code_process() { if ($("#discount_code").val() != "") { $("#discount_code").attr("readonly", "readonly"); $("#discount_code_status").empty().append(\'<i class="fa fa-cog fa-spin fa-lg">&nbsp;</i>\'); $.post("discount_code.php", { discount_code: $("#discount_code").val() }, function(data) { data == 1 ? $("#discount_code_status").empty().append(\'<i class="fa fa-check fa-lg" style="color:#00b100;"></i>\') : $("#discount_code_status").empty().append(\'<i class="fa fa-ban fa-lg" style="color:#ff2800;"></i>\'); $("#discount_code").removeAttr("readonly") }); } } });
    </script>';
 
      $oscTemplate->addBlock($discount_script, 'footer_scripts');

    } // eof execute

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_CP_DISCOUNT_CODE_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Shopping Cart Discount Code Module', 'MODULE_CONTENT_CP_DISCOUNT_CODE_STATUS', 'True', 'Do you want to add the module to your shopping cart?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_CP_DISCOUNT_CODE_CONTENT_WIDTH', '4', 'What width container should the content be shown in?', '6', '2', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_CP_DISCOUNT_CODE_SORT_ORDER', '600', 'Sort order of display. Lowest is displayed first.', '6', '3', now())");
   }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_CP_DISCOUNT_CODE_STATUS', 'MODULE_CONTENT_CP_DISCOUNT_CODE_CONTENT_WIDTH', 'MODULE_CONTENT_CP_DISCOUNT_CODE_SORT_ORDER');
    }
  }
